﻿
var dir = "../Icons/Smileys/", fileextension = ".png", hrefs = [], iconTable = "<table>", row = "", img = 0,
backTaskColor = "#FFA6CA", backProgressColor = "#DD4D71",
currentColorIndex = 0, columnVisible, scrollFromTreeGrid = false;
var isHeaderCheck = false, uiCustomize, alertString = "";
var editSelectedTask;

var predecessorType = {
    "SS": 1,
    "SF": 2,
    "FS": 3,
    "FF": 4
},
predecessorText = {
    "1": "SS",
    "2": "SF",
    "3": "FS",
    "4": "FF"
},
durationUnitValue =
{
    "day": 3,
    "days": 3,
    "hour": 2,
    "hours": 2,
    "mintue": 1,
    "mintues": 1,
},
durationUnitText = {
    1: "mintue",
    2: "hour",
    3: "day"
};
var url = "http://cleardriveproduct.cloudapp.net/v1/";

//Initialize min and max selected days for weekly exception recurrence.
var checkedDaysValue, isEmptyRow, selectedStartDate, selectedEndDate, holidayDataSource = [];
//Mouse right click client side event
function contextMenuOpen(args) {
    var ganttObj = $("#gantt").data("ejGantt"),
        item = args.item,
        predecessorCollection = item.predecessor,
        predecessorLength = predecessorCollection && predecessorCollection.length;
    //args.contextMenuItems.splice(3, 1);
    //args.contextMenuItems.splice(2, 1);
    var index = $.map(args.contextMenuItems, function (item, index) {
        if (item["headerText"] == "Delete") {
            return index;
        }
    });
    args.contextMenuItems.splice(index[0], 1);
    var deleteContextMenu = [{
        headerText: "Delete",
        menuId: "deleteItem",
        eventHandler: customDelete,
    }];
    args.contextMenuItems.push.apply(args.contextMenuItems, deleteContextMenu);
    if (args.item.predecessorsName != undefined && args.item.predecessorsName != "") {
        var deletePredecessorContextMenuItem = [{
            headerText: "Delete Predecessor",
            menuId: "deletepredecessor",
            eventHandler: customMenuAddHandler,
        }];
        args.contextMenuItems.push.apply(args.contextMenuItems, deletePredecessorContextMenuItem);
    }
    var contextMenuItems = [
    {
        headerText: "Change Taskbar Icon",
        menuId: "TaskbarIcons",
        iconClass: "e-smileyIcon"
    },
     {
         headerText: "Child",
         menuId: "Child",
         parentMenuId: "Add",
         eventHandler: customMenuAddHandler,
         iconClass: "e-childIcon"
     },
    {
        menuId: "iconPalette",
        parentMenuId: "TaskbarIcons",
    }];
    args.contextMenuItems.push.apply(args.contextMenuItems, contextMenuItems);
    for (var i = 0; i < predecessorLength; i++) {
        if (item.serialNumber == predecessorCollection[i].from)
            continue;
            //  var headerTextString = "Connector line to " + args.model.updatedRecords[predecessorCollection[i].to - 1].taskName;
        else
            var headerTextString = args.model.updatedRecords[ganttObj.model.ids.indexOf(predecessorCollection[i].from)].taskName;
        //  var headerTextString = "Connector line from " + args.model.updatedRecords[predecessorCollection[i].from - 1].taskName;
        var subcolumn = [{
            headerText: headerTextString,
            menuId: "connectorline" + predecessorCollection[i].from + "to" + predecessorCollection[i].to,
            parentMenuId: "deletepredecessor",
            eventHandler: deletePredecessorHandler,
            iconClass: "e-childIcon"
        }];
        args.contextMenuItems.push.apply(args.contextMenuItems, subcolumn);
    }

    function customMenuAddHandler(args) {
        var ganttObj = $("#gantt").data("ejGantt"),
            currentMenuId = args.menuId,
            tempData = args.data && $.extend({}, args.data.item), rowPosition;
        if (currentMenuId == "Child") {
            rowPosition = ej.TreeGrid.RowPosition.Child;
        }
        ganttObj.addRecord(tempData, rowPosition);
    }
    function deletePredecessorHandler(args) {
        var ganttObj = $("#gantt").data("ejGantt"),
            currentMenuId = args.menuId,
            headerText = args.headerText,
            updatedRecords = args.model.updatedRecords,
            predecessor = args.data.predecessor;

        for (var i = 0; i < predecessor.length; i++) {
            if (currentMenuId == "connectorline" + predecessor[i].from + "to" + predecessor[i].to) {
                var toItem = args.data,
                    fromItem = updatedRecords[ganttObj.model.ids.indexOf(predecessor[i].from)],
                    toItempredecessorIndex = toItem.predecessor.indexOf(predecessor[i]),
                    fromItempredecessorIndex = fromItem.predecessor.indexOf(predecessor[i]),
                    targetString = (predecessor[i].from + predecessor[i].predecessorsType).toString(),
                    predecessorString = toItem.predecessorsName.split(','),
                    toItemDetail = {};

                predecessorString.splice(predecessorString.indexOf(targetString), 1);
                //Remove Particular Connector Line.
                var connectorLineId = "parent" + fromItem['serialNumber'] + "child" + toItem['serialNumber'];
                ganttObj._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                //Update connectorline child Item
                toItem.predecessor.splice(toItempredecessorIndex, 1);
                toItem.item[ganttObj.model.predecessorMapping] = predecessorString.toString();
                toItem.predecessorsName = predecessorString.toString();
                //Update Connectorline Parent Item
                fromItem.predecessor.splice(fromItempredecessorIndex, 1);
                //Refresh Connectorline Child Item.
                ganttObj.refreshGanttRecord(toItem);
            }
        }
    }
    //creating icon palette
    $("body").on({
        mouseenter: function () {
            var iconPalette = $("#iconPalette");
            if (!iconPalette.find("#smileys").length) {
                iconPalette.html("<div id='smileys'></div>");
                $("#smileys").append(iconTable);//.css("background-color", "#cbcbcb");
            }
            var posT = $(this).offset().top + $(this).height();
            pos = posT + iconPalette.height();
            if (pos > $("#gantt").height()) {
                pos = posT - iconPalette.height() - 1;
                $("#iconPalette").closest(".e-innerContextmenu").offset({ top: pos });
            }
            var posL = $(this).offset().left + $(this).width();
            posW = posL + iconPalette.width();
            if (posW > $("#gantt").width()) {
                posW = $(this).offset().left - iconPalette.width() - 1;
                $("#iconPalette").closest(".e-innerContextmenu").offset({ left: posW });
            }
        },
        mouseleave: function () {
        }
    }, '#TaskbarIcons');

    //prevent the default mouseover background color
    $("body").on("mouseover", "#iconPalette", function () {
        $(this).removeClass("e-contextmenu-mouseover");
    });

    //add mouseover background color for each icon in icon palette
    $("body").on({
        mouseenter: function () {
            $(this).closest("td").addClass("e-contextmenu-mouseover");
        },
        mouseleave: function () {
            $(this).closest("td").removeClass("e-contextmenu-mouseover");
        }
    }, '.smileyIcons');


    $("body").on("mousedown", ".smileyIcons", function () {
        var ganttOb = $("#gantt").data("ejGantt"),
            selectedItem = ganttOb.model.selectionMode == "row" ? ganttOb.model.selectedItem :
            ganttOb.model.updatedRecords[ganttOb._rowIndexOfLastSelectedCell];
        currentDataIndex = ganttOb.model.currentViewData.indexOf(selectedItem);
        imageURL = $(this).find("img").attr("src");
        var imgName = imageURL.substring(imageURL.lastIndexOf("/") + 1, imageURL.lastIndexOf("."));
        if (imgName == "Icons-09")
            selectedItem["image"] = null;
        else
            selectedItem["image"] = imgName;
        ganttOb._$ganttchartHelper.ejGanttChart("refreshRow", currentDataIndex);
        ganttOb._$treegridHelper.ejTreeGrid("refreshRow", currentDataIndex);
    });
}
//Method to select the row using task id
function selectRowByTaskId(taskID) {
    var ganttOb = $("#gantt").data("ejGantt"),
        updatedRecords = ganttOb.model.updatedRecords,
        recordIndex;
    recordIndex = $.map(updatedRecords, function (record, i) {
        if (record.taskId == taskID)
            return i;
    });
    ganttOb.selectRows(recordIndex[0]);
}

function showNotification(message) {

    angular.element(document.getElementById('rootid')).scope().showNotification(message);
}

function addOrRemoveConnectorLine(predecessorCollection, isAdded, taskId) {
    var ganttObj = $("#gantt").data("ejGantt"),
        model = ganttObj.model,
        predecessorType,
        selectedItem = model.selectedItem,
        updatedRecords = model.updatedRecords,        
        length = predecessorCollection.length,
        existingPredecessor = selectedItem.predecessor,
        predecessorArgs = {
            previousPredecessor: existingPredecessor
        },
        addedPredecessor = [],
        selectedItemPredecessor = [],
        parentGanttRecord,
        modifiedPredecessorString = "";
    for (var i = 0; i < length; i++) {
        predecessorType=predecessorCollection[i].predecessorType;
        if (ej.isNullOrUndefined(predecessorType))
            predecessorType = "FS";
        modifiedPredecessorString += predecessorCollection[i].taskId + predecessorType;
        if (i != length - 1)
            modifiedPredecessorString += ", ";
    }
    if (modifiedPredecessorString != "")
        addedPredecessor = selectedItem._calculatePredecessor(modifiedPredecessorString);
    if (existingPredecessor) {
        for (var index = 0; index < existingPredecessor.length; index++) {
            var predecessor = existingPredecessor[index];
            if (predecessor.from === selectedItem.taskId.toString()) {
                selectedItemPredecessor.push(predecessor);
            }
        }
    }
    for (var count = 0; count < addedPredecessor.length; count++) {
        selectedItemPredecessor.push(addedPredecessor[count]);
    }
    //if (modifiedPredecessorString.indexOf(",") == 0)
    //    modifiedPredecessorString.slice(1);
    selectedItem.predecessor = selectedItemPredecessor;
    selectedItem.serialNumberPredecessor = modifiedPredecessorString;
    selectedItem.predecessorsName = modifiedPredecessorString;
    selectedItem.item[model.predecessorMapping] = modifiedPredecessorString;
    if (model.enableSerialNumber)
        ganttObj._updateserialNumberPredecessor(selectedItem.predecessorsName, selectedItem)

    //proxy._$treegridHelper.ejTreeGrid("updatePredecessorValue", modifiedPredecessorString, true, selectedItem);

    predecessorArgs.columnName = "serialNumberPredecessor";
    predecessorArgs.data = selectedItem;

    ganttObj._updateEditedGanttRecords(predecessorArgs);
    var args = {
        updatedRecords: ganttObj._overallActionComplete
    }
    if (isAdded && existingPredecessor.length < selectedItem.predecessor.length) {
        showNotification("Task link created");
        ModifiedTask = args.currentRecord; //Newly created connector line task detail.
        updateTask(selectedItem, args, 'drawConnectorLine');
    }
    if (!isAdded && existingPredecessor.length > selectedItem.predecessor.length) {
        showNotification("Task link removed");
        //Need to updated two data while remove the connector link.
        // args.fromRecord and args.toRecord
        parentGanttRecord = updatedRecords[model.ids.indexOf(taskId.toString())];
        updateTask(parentGanttRecord, args, 'removeLink', selectedItem);
        // updateTask(args.toRecord, args, 'removeLink');
    }

}

function chartActionComplete(args) {
    var ModifiedTask;
    switch (args.requestType) {
        case "scroll":            
            angular.element(document.getElementById('gantt')).scope().ShowScrollOptions();
            break;            
		//case "pdfBase64":
        //    angular.element(document.getElementById('gantt')).scope().exportPDF(args.base64);
        //    break;
        case "xmlBase64":
            angular.element(document.getElementById('gantt')).scope().exportXML(args.base64);
            break;
        case "save":
            if (args.isMultipleAdd) { 
                //Get the newly added record from args._cAddedRecord                
                updateMultiTask(args._cAddedRecord, args.updatedRecords, 'addNewtask');                
                projectProgressValue();
            }
            else if (args._cAddedRecord) {
                updateTask(args._cAddedRecord, args, 'addNewtask');
                ModifiedTask = args._cAddedRecord; //Newly added task detail
                showNotification("Added the new Task: " + (args._cAddedRecord.taskName));
                projectProgressValue();
            }
            else
                showNotification("Edited the Task");
            break;
        case "delete":         
            if (!args.isMultipleDelete) {
                deleteTask(args.data, args, 'deleteTask');
            }else {
                deleteMultipleTask(args);                
            }
            projectProgressValue();
            showNotification("Deleted the Task: " + (args.data.taskName));
            break;
        case "indent":
            ModifiedTask = args.data //Indent task detail
            updateTask(ModifiedTask, args, 'indent');
            showNotification("Indented the Task: " + (args.data.taskName));
            projectProgressValue();
            break;
        case "outdent":
            ModifiedTask = args.data //Outdent task detail
            updateTask(ModifiedTask, args, 'outdent');
            showNotification("Outdented the Task: " + (args.data.taskName));
            projectProgressValue();
            break;
        case "drawConnectorLine":
            showNotification("Task link created");
            ModifiedTask = args.currentRecord; //Newly created connector line task detail.
            updateTask(ModifiedTask, args, 'drawConnectorLine');
            break;
        case "removeLink":
            showNotification("Task link removed");
            //Need to updated two data while remove the connector link.
            // args.fromRecord and args.toRecord
            updateTask(args.fromRecord, args, 'removeLink', args.toRecord);
            // updateTask(args.toRecord, args, 'removeLink');
            break;
        //case "validatePredecessor":
        //    if (args.model.enablePredecessorValidation && args.fromItem) {
        //        var fromItem = args.fromItem;
        //        if (fromItem.predecessor && fromItem.predecessor.length) {
        //            var exists = $.map(fromItem.predecessor, function (predecessorItem, index) {
        //                if (predecessorItem.from == fromItem.taskId)
        //                    return true;
        //            });
        //            if (exists[0]) {
        //                showNotification("Only one predecessor and one successor will be allowed for a task");
        //                args.cancel = true;
        //            }
        //        }
        //    }
        //    break;
        case "summaryLinkValidation":
            showNotification("Can't create link with summary task");
            break;
        case "recordUpdate":
            if (args.data.isEndEdit) {
                args.data.isEndEdit = false;
            }
            ModifiedTask = args.data; //Updated task detail
            if (args.isDrawPredecessor)
                updateTask(ModifiedTask, args, 'drawConnectorLine');
            else
                updateTask(ModifiedTask, args, 'recordUpdate');
            var gObj = $("#gantt").data("ejGantt");
            if (gObj.isProgressUpdated) {
                projectProgressValue();
                gObj.isProgressUpdated = false;
            }
            break;
        case "dragAndDrop":
            // Need to update two data while performing drag and drop.
            // args.draggedRow and args.targetRow
            //args.draggedRow.updatedTasks = args.targetRow;
            var iconLock = $("#LockChange").attr('class').indexOf('lockclose') != -1 ? 'lockopen' : "lockclose";
            if (iconLock == "lockopen")
                return;
            dragAndDrop_Task_Update(args, args.draggedRow, args.targetRow, 'dragAndDrop');
            projectProgressValue();

            //args.updatedRecords = args.targetRow.childRecords;
            //updateTask(args.targetRow, args, 'dragAndDrop');
            break;
        case "calculateDimension":
            // args.height = args.height - 25;
            break;
        case "pdfHtmlString":
            angular.element(document.getElementById('gantt')).scope().exportPDF(args.htmlString,args.width,args.height);
            break;

        case "logicalIdUpdate":            
            updateDuplicateLogicalID(args.updatedRecords);
            break;
    }
}

//Function for avoiding duplicate logical updates in server
function updateDuplicateLogicalID(updateTasks) {

    var updateSource = [];
    if (updateTasks && updateTasks.length > 0) {
        for (var k = 0, totalCount = updateTasks.length; k < totalCount; k++) {
            var data = updateTasks[k],
                item = {};
            if (data && data.isEmptyRecord)
                continue;
            item.local_task_id = data.taskId,
            item.logical_id = data.serialNumber - 1;
            updateSource.push(item);
        }
    }

    updateSource.length > 0 ? angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks(updateSource, "UpdateDuplicateLogicalId") : angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks([], "UpdateDuplicateLogicalId");

}

//Function for update progress
var projectProgress;
function projectProgressValue() {
    var ganttObj = $("#gantt").data("ejGantt"),
        updatedRecords = ganttObj.model.updatedRecords,
        totalProgess = 0, tot = 0;
    for (var i = 0; i < updatedRecords.length; i++) {
        if (!updatedRecords[i].isEmptyRecord && updatedRecords[i].level == 0) {
            totalProgess += +(updatedRecords[i].status);
            tot++;
        }
        projectProgress = totalProgess / tot;
    }

    angular.element(document.getElementById('slideMenuTool')).scope().updateProgress(projectProgress);
}

//Function for update multitasks
function updateMultiTask(taskList, updateTaskList) {

    var newTasks = [], updatedTasks = [];

    newTasks = (taskList && taskList.length > 0) ? convertDataSource(taskList) : [];

    updatedTasks = (updateTaskList && updateTaskList.length > 0) ? convertDataSource(updateTaskList) : [];


    angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks(updatedTasks, "AddMultiTasks", newTasks);
}

//Function for update intendTask
function updateTask(sourceRecord, args, updateType, targetRecord) {

    var dataSource = [],

      updatedRecods = args.updatedRecords ? args.updatedRecords : [],

      totalUpdatedRecords = [];

    //Check whether updated child records exist
    if (updatedRecods.length > 0) {

        totalUpdatedRecords = updatedRecods;
    }


    for (var k = 0; k < totalUpdatedRecords.length; k++) {

        var data = totalUpdatedRecords[k];
        var item = {};

        if (data && data.isEmptyRecord)
            continue;

        item.local_task_id = data.taskId,
        item.title = data.taskName;
        item.indentation = data.level;
        item.start = ej.format(data.startDate, "yyyy-MM-dd");
        item.finish = ej.format(data.endDate, "yyyy-MM-dd");
        item.parent_id = data.parentItem ? (data.parentItem.serialNumber - 1) : -1;
        item.local_parent_task_id = data.parentItem ? data.parentItem.taskId : -1;
        item.logical_id = data.serialNumber - 1;
        item.description = ej.isNullOrUndefined(data.item.notesHTML) ? "" : data.item.notesHTML;
        item.dependencies = data.predecessor ? getPredecessor(data.predecessor, data.taskId) : [];
        item.assignments = (data.resourceInfo && data.resourceInfo.length) ? data.resourceInfo : [];
        item.percent_done = data.status;
        item.manually_scheduled = data.item.isManual ? 1 : 2;
        item.duration = data.duration;
        item.duration_unit = durationUnitValue[data.durationUnit.toLowerCase()];
        item.display_task_color_code = data.item.taskColor ? data.item.taskColor : "";
        item.display_progress_color_code = data.item.progressColor ? data.item.progressColor : "";
        item.attachments_count = data.item.attachment ? parseInt(data.item.attachment) : 0;
        dataSource.push(item);
    }

    var targetData, fromRecord, toRecord;


    if (updateType == "removeLink" || updateType == "drawConnectorLine") {

        targetData = [];

        if (updateType == "removeLink") {
            fromRecord = convertDBTask(sourceRecord);
            toRecord = convertDBTask(targetRecord);

            dataSource.push(fromRecord);
            dataSource.push(toRecord);

            targetData.push(fromRecord);
            targetData.push(toRecord);
        }
        else {
            toRecord = convertDBTask(sourceRecord);
            dataSource.push(toRecord);
            targetData.push(toRecord);
        }
    }
    else {
        targetData = convertDBTask(sourceRecord);
    }

    angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks(dataSource, updateType, targetData);

}

//Function for add or update new task
function convertDBTask(data) {

    var item = {};
    if (data && data.isEmptyRecord)
        return item;
    item.local_task_id = data.taskId,
    item.parentItem = data.parentItem ? data.parentItem : null;
    item.title = data.taskName;
    item.indentation = data.level;
    item.start = ej.format(data.startDate, "yyyy-MM-dd");
    item.finish = ej.format(data.endDate, "yyyy-MM-dd");
    item.parent_id = data.parentItem ? (data.parentItem.serialNumber - 1) : -1;
    item.local_parent_task_id = data.parentItem ? data.parentItem.taskId : -1;
    item.logical_id = data.serialNumber - 1;
    item.description = ej.isNullOrUndefined(data.item.notesHTML) ? "" : data.item.notesHTML;
    item.dependencies = data.predecessor ? getPredecessor(data.predecessor, data.taskId) : [];
    item.assignments = (data.resourceInfo && data.resourceInfo.length) ? data.resourceInfo : [];
    item.percent_done = data.status;
    item.manually_scheduled = data.item.isManual ? 1 : 2;
    item.duration = data.duration;
    item.duration_unit = durationUnitValue[data.durationUnit.toLowerCase()];
    item.display_task_color_code = data.item.taskColor ? data.item.taskColor : "";
    item.display_progress_color_code = data.item.progressColor ? data.item.progressColor : "";
    item.attachments_count = data.item.attachment ? parseInt(data.item.attachment) : 0;
    item.display_progress_image_name = data.image != null ? data.image : null;

    return item;

}

//Function for update drag and drop tasks
function dragAndDrop_Task_Update(args, sourceRecord, dragTarget, updateType) {

    var targetTask = convertDBTask(sourceRecord);
    targetTask.childRecords = sourceRecord.childRecords ? sourceRecord.childRecords : [];
    targetTask.updatedTasks = [];
    targetTask.updatedTasks.push(dragTarget);

    var updatedRecods = args.updatedRecords ? args.updatedRecords : [],

    updatedtasks = convertDataSource(updatedRecods);

    angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks(updatedtasks, updateType, targetTask);

}


//Function for delete task
function deleteTask(sourceRecord, args, updateType) {

    var targetTask = convertDBTask(sourceRecord); updatedtasks = [];
    targetTask.childRecords = sourceRecord.childRecords ? sourceRecord.childRecords : [];

    var updatedRecods = args.updatedRecords ? args.updatedRecords : [];

    var updatedSourceObject = multipleRecordsDatasource(updatedRecods);

    updatedSourceObject.undoTaskIds.push(targetTask.local_task_id);

    angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks(updatedSourceObject, updateType, targetTask);

}

//Function for deleting multiple tasks
function deleteMultipleTask(args) {
    args.updatedRecords = args.updatedRecords && args.updatedRecords.length > 0 ? args.updatedRecords : [];
    var updatedSource = multipleRecordsDatasource(args.updatedRecords);
    var taskIds = updatedSource.undoTaskIds;
    var deletedItems = convertDataSource(args.deletedItems);

    for (var k = 0, len = deletedItems.length; k < len; k++)
        taskIds.push(deletedItems[k].local_task_id);

    angular.element(document.getElementById('slideMenuTool')).scope().UpdateScheduleTasks(updatedSource.updatedRecords, 'multipleTaskDelete', deletedItems, taskIds);

}

function multipleRecordsDatasource(totalUpdatedRecords) {

    var allDataSource = [], dataSource = [], taskIds=[];

    for (var k = 0; k < totalUpdatedRecords.length; k++) {

        var data = totalUpdatedRecords[k];
        var item = {};

        if (data && data.isEmptyRecord)
            continue;
        taskIds.push(data.taskId);
        item.local_task_id = data.taskId,
        item.title = data.taskName;
        item.indentation = data.level;
        item.start = ej.format(data.startDate, "yyyy-MM-dd");
        item.finish = ej.format(data.endDate, "yyyy-MM-dd");
        item.parent_id = data.parentItem ? (data.parentItem.serialNumber - 1) : -1;
        item.local_parent_task_id = data.parentItem ? data.parentItem.taskId : -1;
        item.logical_id = data.serialNumber - 1;
        item.description = ej.isNullOrUndefined(data.item.notesHTML) ? "" : data.item.notesHTML;
        item.dependencies = data.predecessor ? getPredecessor(data.predecessor, data.taskId) : [];
        item.assignments = (data.resourceInfo && data.resourceInfo.length) ? data.resourceInfo : [];
        item.percent_done = data.status;
        item.manually_scheduled = data.item.isManual ? 1 : 2;
        item.duration = data.duration;
        item.duration_unit = durationUnitValue[data.durationUnit.toLowerCase()];
        item.display_task_color_code = data.item.taskColor ? data.item.taskColor : "";
        item.display_progress_color_code = data.item.progressColor ? data.item.progressColor : "";
        item.attachments_count = data.item.attachment ? parseInt(data.item.attachment) : 0;

        if (dataSource.length > 50) {

            allDataSource.push(dataSource);
            dataSource = [];
            dataSource.push(item);

        } else {

            dataSource.push(item);
        }
        
    }

    dataSource && dataSource.length > 0 ? allDataSource.push(dataSource) : 0;

    return { updatedRecords: allDataSource, undoTaskIds: taskIds } ;

}
 
//Convert gantt datasource
function convertDataSource(totalUpdatedRecords) {

    var dataSource = [];

    for (var k = 0; k < totalUpdatedRecords.length; k++) {

        var data = totalUpdatedRecords[k];
        var item = {};

        if (data && data.isEmptyRecord)
            continue;

        item.local_task_id = data.taskId,
        item.title = data.taskName;
        item.indentation = data.level;
        item.start = ej.format(data.startDate, "yyyy-MM-dd");
        item.finish = ej.format(data.endDate, "yyyy-MM-dd");
        item.parent_id = data.parentItem ? (data.parentItem.serialNumber - 1) : -1;
        item.local_parent_task_id = data.parentItem ? data.parentItem.taskId : -1;
        item.logical_id = data.serialNumber - 1;
        item.description = ej.isNullOrUndefined(data.item.notesHTML) ? "" : data.item.notesHTML;
        item.dependencies = data.predecessor ? getPredecessor(data.predecessor, data.taskId) : [];
        item.assignments = (data.resourceInfo && data.resourceInfo.length) ? data.resourceInfo : [];
        item.percent_done = data.status;
        item.manually_scheduled = data.item.isManual ? 1 : 2;
        item.duration = data.duration;
        item.duration_unit = durationUnitValue[data.durationUnit.toLowerCase()];
        item.display_task_color_code = data.item.taskColor ? data.item.taskColor : "";
        item.display_progress_color_code = data.item.progressColor ? data.item.progressColor : "";
        item.attachments_count = data.item.attachment ? parseInt(data.item.attachment) : 0;
        dataSource.push(item);
    }

    return dataSource;
}

//Convert the Json dependency as predecessor.
function getPredecessor(data, taskId) {
    var length = data.length, predecessor = [];
    for (var i = 0; i < length; i++) {
        if (data[i].from != taskId) {
            var item = {};
            item.task_id = parseInt(data[i].from);
            item.type = predecessorType[data[i].predecessorsType];
            item.offset = isNaN(parseInt(data[i].offset)) ? 0 : parseInt(data[i].offset);
            item.offset_unit = 3;
            predecessor.push(item);
        }
    }
    return predecessor;
}

function taskBarEditing(args) {
    if (currentProjectHavingConflicts || ScheduleLockedOrLinkActive()==false) {
        args.cancel = true;
    }
}

function taskbarEdited(args) {
    var modifiedData;
    modifiedData = args.data; //Edited task detail
}
function queryCellInfo(args) {
    if (args.column.field == "result") {
        var checkboxElem = $(args.cellElement).find(".checkboxItems"),
            controlArgs = {};
        controlArgs.size = "medium";
        controlArgs.showRoundedCorner = true;
        controlArgs.change = rowsCheckbox;
        checkboxElem.ejCheckBox(controlArgs);
    }
    //if (args.column.field == "attachment") {
    //    $(args.cellElement).find(".attachmentcount").text(args.cellValue);
    //}
    //else if ($(args.cellElement).find(".serialcol").length > 0) {
    //    var tdata = args.data, background = "";
    //    if (!tdata.item.taskColor && !tdata.item.progressColor && (tdata.hasChildRecords || !tdata.parentItem)) {
    //        if (currentColorIndex >= backColorCollection.length)
    //            currentColorIndex = 0;
    //        if (!tdata.item.taskColor)
    //            tdata.item.taskColor = backColorCollection[currentColorIndex];
    //        if (!tdata.item.progressColor)
    //            tdata.item.progressColor = progressColorCollection[currentColorIndex];
    //        currentColorIndex += 1;
    //    }
    //    if (tdata.hasChildRecords)
    //        background = tdata.item.progressColor;
    //    else if (tdata.parentItem)
    //        background = tdata.parentItem.item.progressColor;
    //    else
    //        background = tdata.item.progressColor;
    //    $(args.cellElement).find(".serialcol").css("background-color", background);
    //}
}
function endEdit(args) {
    if ($("#customEditor").data("ejDialog"))
        $("#customEditor").ejDialog("close");
    showNotification("Edited the Task: " + (args.data.taskId));
}

function beginEdit(args) {
    if (args.editActionFrom == "chart" && !args.data.isEmptyRecord) {
        angular.element(document.getElementById('gantt')).scope().selectRow(args);
    } else {
        args.cancel = true;
    }
}

function ganttDragStart(args) {
    var iconLock = $("#LockChange").attr('class').indexOf('lockclose') != -1 ? 'lockopen' : "lockclose";
    if (iconLock == "lockopen") {
        args.cancel = true;      
    }
    if (currentProjectHavingConflicts) {
        args.cancel = true;
        angular.element(document.getElementById('gantt')).scope().showConflictPopup();
    }
}

function onClosing(args) {
    if (args.event)
        $("#gantt").data("ejGantt")._$treegridHelper.ejTreeGrid("cancelEditCell");
}
function saveClick(args) {

    $("#ejTreeGridganttEditForm").children("input").val($("#autoComp").ejAutocomplete("model.value"));
    $("#customEditor").ejDialog("close");
    $("#gantt").data("ejGantt")._$treegridHelper.ejTreeGrid("saveCell");
}
function cancelClick(args) {
    $("#customEditor").ejDialog("close");
    $("#gantt").data("ejGantt")._$treegridHelper.ejTreeGrid("cancelEditCell");
}

function load(args) {
    this._scrollBarHeight = 0;
    var uiCustomizeValue = uiCustomize.uiCustomize,
        treeColumns = uiCustomizeValue.visibilityOfTaskColumns;
    var weekAbbr = uiCustomizeValue.weekdayAbbr,
        weekAbbrLength = weekAbbr.length,
        weekday = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
    for (var i = 0; i < weekAbbrLength; i++) {
        this._dayFormat[weekday[i].substring(0, 3)] = weekAbbr[i][weekday[i]];
    }
    currentColorIndex = 0;
    var columns = this.getColumns();
    columns[1].isFrozen = true;
    if ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i))) {
        columns[1].isFrozen = false;
        columns[3].isFrozen = false;
    }
    columns[0].width = 52;
    columns[1].width = 50;   
    columns[3].width = 180;//Task name column
    columns[6].visible = true;
    columns[7].visible = true;
    columns[8].visible = true;

    if (this._id == "proxy_gantt") {
        var pdfColumn = uiCustomize.pdf.pdfoutlineTaskColumns,
            columnsLength = columns.length,
            isDefault = true, value;
        columns[0].isFrozen = columns[1].isFrozen = columns[2].isFrozen = false;
        columns[2].width = (getTaskIndentLevel() * 50) + 200;
        columns[1].visible = false;
        columns[3].visible = false;
        this.model.treeColumnIndex = 2;
        for (var i = 0; i < columnsLength; i++) {
            switch (columns[i].field) {
                case "startDate":
                    columns[i].visible = pdfColumn[2].start;
                    break;
                case "endDate":
                    columns[i].visible = pdfColumn[3].finish;
                    break;
                case "status":
                    columns[i].visible = pdfColumn[5].compPercentage;
                    break;
                case "duration":
                    columns[i].visible = pdfColumn[4].duration;
                    break;
                case "notes":
                    columns[i].visible = pdfColumn[14].notes;
                    break;
                case "resourceInfo":
                    columns[i].visible = pdfColumn[6].resource;
                    break;
                case "serialNumberPredecessor":
                    columns[i].visible = pdfColumn[15].predecessor;
                    break;
                case "taskMode":
                    columns[i].visible = pdfColumn[16].taskmode;
                    break;
                case "work":
                    columns[i].visible = pdfColumn[17].work;
                    break;
                case "attachment":
                    columns[i].visible = pdfColumn[18].attachment;
            }
        }
        return true;
    }
    ganttObj1 = $("#gantt").data("ejGantt");
    if (ganttObj1.model.isReRenderChart)
        return;
    //columns[0].isTemplateColumn = true;
    //columns[0].templateID = "idTemplate";
    //columns[0].width = "60px";

    //columns[2].isTemplateColumn = true;
    //columns[2].templateID = "autoManualTemplate";
    //columns[2].width = "105px";
    //columns[1].visible = false;
    //columns[6].visible = false;
    //columns.splice(1, 0,
    //   {
    //       field: "tempId",
    //       headerText: "TID",
    //       width: "180px",
    //       allowEditing: false,
    //       visible: false
    //   });
    //columns.splice(2, 0,
    //   {
    //       field: "result",
    //       // headerText: "Result",
    //       headerTemplateID: "#resultTemp",
    //       headerTextAlign: "center",
    //       //textAlign: "center",
    //       isTemplateColumn: true,
    //       templateID: "checkboxTemplate",
    //       allowEditing: false,
    //       width: "75px",
    //       mappingName:"result"
    //   });

    //columns.splice(6, 0,
    //  {
    //      field: "customResources",
    //      headerText: "Custom Resources",
    //      isTemplateColumn: true,
    //      templateID: "customResourcesTemplate",
    //      width: "180px",
    //      mappingName:"customResources"
    //  });
    //columns.splice(9, 0,
    //  {
    //      field: "oneNote",
    //      headerText: "One Note",
    //      isTemplateColumn: true,
    //      templateID: "noteTemplate",
    //      allowEditing: false,
    //      width: "70px"
    //  });
    //columns.splice(10, 0,
    //  {
    //      field: "discussion",
    //      headerText: "Discussion",
    //      isTemplateColumn: true,
    //      templateID: "chatTemplate",
    //      allowEditing: false,
    //      width: "105px"
    //  });

    //columns.splice(11, 0,
    //  {
    //      field: "attachment",
    //      headerText: "Attachment",
    //      isTemplateColumn: true,
    //      templateID: "attachTemplate",
    //      allowEditing: false,
    //      width: "110px",
    //      mappingName: "attachment"
    //  });
    //columns.splice(11, 0,
    //  {
    //      field: "print",
    //      headerText: "Print",
    //      isTemplateColumn: true,
    //      templateID: "printTemplate",
    //      width: "60px",
    //      allowEditing: false,
    //      visible: false
    //  });
    //columns.push(
    //   {
    //       field: "taskColor",
    //       headerText: "TaskColor",
    //       visible: false
    //   });
    //columns.push(
    //   {
    //       field: "progressColor",
    //       headerText: "ProgressColor",
    //       visible: false
    //   });
    //var taskModeColumn = columns[4];
    //columns.splice(4, 1);
    //columns.push(taskModeColumn);
    //columns[7].width = columns[8].width = columns[10].width = columns[11].width = columns[12].width = columns[14].width = 90;
    //columns[5].width = 180;
    ganttObj1.model.treeColumnIndex = 3;
    //var column = {
    //    field: "image",
    //    headerText: "image",
    //    visible: false,
    //    mappingName: "image"
    //};
    //columns.push(column);
    //var localColumn = {
    //    field: "localTaskId",
    //    headerText: "Local Task Id",
    //    visible: false,
    //    mappingName: "localTaskId"
    //};
    //columns.push(localColumn);
    var resource = {};
    resource.resource = [];
    this.model.resources = resource.resource;
    var lockProjectByDefault = localStorage.getItem("lockByDefault");
    if (lockProjectByDefault == "true") {
        ganttObj1.model.editSettings = {
            allowEditing: false,
            allowAdding: false,
            allowDeleting: false,
            editMode: "cellEditing"
        }
        ganttObj1.model.allowGanttChartEditing = false;
    }
    else {
        ganttObj1.model.editSettings = {
            allowEditing: true,
            allowAdding: true,
            allowDeleting: true,
            editMode: "cellEditing"
        }
        ganttObj1.model.allowGanttChartEditing = true;
    }
    var columnsLength = columns.length;
    for (var i = 0; i < columnsLength; i++) {
        switch (columns[i].field) {
            case "startDate":
                columns[i].visible = treeColumns[1].start;
                break;
            case "endDate":
                columns[i].visible = treeColumns[2].finish;
                break;
            case "status":
                columns[i].visible = treeColumns[6].progress;
                break;
            case "duration":
                columns[i].visible = treeColumns[5].duration;
                break;
            case "attachment":
                columns[i].visible = treeColumns[3].attachment;
                break;
            case "notes":
                columns[i].visible = treeColumns[7].notes;
                break;
            case "resourceInfo":
                columns[i].visible = treeColumns[4].resource;
                columns[i].dropdownData = resource.resource;
                break;
            case "serialNumberPredecessor":
                columns[i].visible = treeColumns[8].predecessor;
                break;
            case "taskMode":
                columns[i].visible = treeColumns[9].taskmode;
                break;
            case "work":
                columns[i].visible = treeColumns[10].work;
                //case "predecessor":
                //    columns[i].visible = treeColumns[12].predecessor;
                //    break;
                //case "customResources":
                //    columns[i].visible = treeColumns[5].resource;
                //    break;
        }
    }
}
function getTaskIndentLevel() {
    var ganttObjD = $("#gantt").data("ejGantt"),
        ganttRecords = ganttObjD.model.updatedRecords,
        lastIndent = 0;
    for (var i = 0; i < ganttRecords.length; i++) {
        if (ganttRecords[i].level > lastIndent)
            lastIndent = ganttRecords[i].level;
    }
    return lastIndent;
}
function assignColumns(columns) {
    columnVisible = columns;
}
function create(args) {
    var toolbar = $("#" + this._id + "_toolbarItems");
    //Toolbar item to be added
    var toolbarItem = '<li tabindex= "0" title="Calender" id="calendarSettings"><span id="calendericon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Lock" id="lock_customicon"><span  id="lockicon" class="gantt_customicon lockicon" ></span></li>';

    toolbarItem += '<li tabindex= "0" title="Outdent" id="outdent_customicon"><span  id="outdenticon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Indent" id="indent_customicon"><span  id="indenticon" class="gantt_customicon"> </span></li>';

    toolbarItem += '<li tabindex= "0" title="Template" id="Template_customicon"><span  id="Templateicon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Export" id="export_customicon"><span  id="exporticon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Format" id="format_customicon"><span  id="formaticon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Collapse All" id="collapse_customicon"><span  id="collapseicon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Expand All" id="expand_customicon"><span  id="expandicon" class="gantt_customicon" id="expandicon"></span></li>';

    //toolbarItem += '<li tabindex= "0" title="Zoom To Fit" id="zoomtofit_customicon"><span id="zoomtofiticon" class="gantt_customicon"></span></li>';

    //toolbarItem += '<li tabindex= "0" title="Zoom Out" id="zoomout_customicon"><span id="zoomouticon" class="gantt_customicon"></span></li>';

    //toolbarItem += '<li tabindex= "0" title="Zoom In" id="zoomin_customicon"><span id="zoominicon" class="gantt_customicon"></span></li>';
    toolbarItem += '<li tabindex= "0" title="Delete" id="delete_customicon"><span  id="deleteicon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Edit" id="edit_customicon"><span  id="editicon" class="gantt_customicon"></span></li>';

    toolbarItem += '<li tabindex= "0" title="Add" id="add_customicon" "><span  id="addicon" class="gantt_customicon"></span></li>';

    toolbarItem += '<div style="display:inline-block;float:right;position:relative;right:100px;top:14px">';
    toolbarItem += '<div id="hour_schedule" class="schedulebutton"">Hour</div>';
    toolbarItem += '<div id="day_schedule" class="schedulebutton selectedschedulemode">Day</div>';
    toolbarItem += '<div id="week_schedule" class="schedulebutton">Week</div>';
    toolbarItem += '<div id="month_schedule" class="schedulebutton" >Month</div></div>';
    $(toolbar).children().first().append(toolbarItem);
    if (isHeaderCheck)
        $("#resultCheck").prop("checked", "checked");

    var splitter = document.getElementsByClassName("e-split-divider")[0],
        splitterSpan = document.createElement('span'),
        splitterImage = document.createElement("img");
    $(splitterImage).attr("src", 'Icons/SplitterIcon40.png');
    $(splitterImage).css({ 'height': '40px', 'width': '40px' });
    splitterSpan.appendChild(splitterImage);
    $(splitterSpan).css({
        'z-index': 100,
        'position': 'absolute',
        'margin-top': "50%",
        'margin-left': '-17px',
    });
    $(splitterSpan).attr('class', "splitterCustom");
    splitter.appendChild(splitterSpan);
    //Rendering header check box with ej
    renderCheckBox();
}

function renderCheckBox() {
    var controlArgs = {};
    controlArgs.size = "medium";
    controlArgs.showRoundedCorner = true;
    controlArgs.change = headerCheck;
    $("#resultCheck").ejCheckBox(controlArgs);
}
//function queryTaskbarInfo(args) 
    //var tdata = args.data;
    ////Applying Background colors
    //if (tdata.hasChildRecords) {
    //    args.parentTaskbarBackground = tdata.item.taskColor;
    //    args.parentTaskbarBorder = tdata.item.taskColor;
    //    args.parentProgressbarBackground = tdata.item.progressColor;
    //    args.parentProgressbarBorder = tdata.item.progressColor;
    //}
    //else {
    //    args.taskbarBackground = tdata.item.taskColor;
    //    args.taskbarBorder = tdata.item.taskColor;
    //    args.progressbarBackground = tdata.item.progressColor;
    //    args.progressbarBorder = tdata.item.progressColor;
    //}
//}
//Color for taskbar
function taskColorChange(color) {
    var newTaskColor;
    switch (color) {
        case "#53B7A4":
            newTaskColor = "#9AFEEB";
            break;
        case "#A3BC5F":
            newTaskColor = "#D9F295";
            break;
        case "#5FA0CB":
            newTaskColor = "#A6E7FF";
            break;
        case "#F79968":
            newTaskColor = "#FFE0AF";
            break;
        case "#F296CE":
            newTaskColor = "#FFCCFF";
            break;
        case "#FFD35C":
            newTaskColor = "#FFFFA3";
            break;
        case "#40A840":
            newTaskColor = "#87EF87";
            break;
        case "#407A88":
            newTaskColor = "#87C1CF";
            break;
        case "#4778C6":
            newTaskColor = "#8EBFFF";
            break;
        case "#987C5C":
            newTaskColor = "#DFC3A3";
            break;
        case "#5B2096":
            newTaskColor = "#C68BFF";
            break;
        case "#555855":
            newTaskColor = "#9C9F9C";
            break;
        case "#55A3E5":
            newTaskColor = "#8BD9FF";
            break;
        case "#B194D2":
            newTaskColor = "#E7CAFF";
            break;
        case "#DD4D71":
            newTaskColor = "#FFA6CA";
            break;
        case "#887488":
            newTaskColor = "#CFBBCF";
            break;
        case "#E9AA4C":
            newTaskColor = "#FFF193";
            break;
        case "#9FA9AA":
            newTaskColor = "#D5DFE0";
            break;
    }
    return newTaskColor;
}

function changeChildTaskColor(data, color) {
    var ganttObj = $("#gantt").data("ejGantt"),
        childItems = data.childRecords;
    for (var i = 0; i < childItems.length; i++) {
        ganttObj._isLastRefresh = true;
        var dataItem = childItems[i].item;
        childItems[i].progressColor = dataItem["progressColor"] = color;
        childItems[i].taskColor = dataItem["taskColor"] = taskColorChange(color);
        ganttObj.refreshGanttRecord(childItems[i]);
        ganttObj.refreshGanttRecord(data, false, true);
        if (childItems[i].hasChildRecords)
            changeChildTaskColor(childItems[i], color);
        ganttObj._isLastRefresh = false;
    }
}
//Duration value update with corresponding end date
function setDurationEndDate(duration) {
    var gObj = $("#gantt").data("ejGantt"),
        selectedItem = gObj.model.selectedItem;
    selectedItem.duration = duration;
    selectedItem.item[gObj.model.durationMapping] = duration;
    gObj.calculateEndDate(selectedItem);
    selectedItem.endDate = gObj._$ganttchartHelper.ejGanttChart("instance")._currentEditedRecord.endDate;
    selectedItem.item[gObj.model.endDateMapping] = selectedItem.endDate;
    if (selectedItem.isMilestone)
        selectedItem.isMilestone = false;
    gObj._updatedColumn = "duration";
    gObj._updateResourceRelatedFields(selectedItem);
    gObj._updateGanttRecord(selectedItem);
    gObj._removeConnectorLine(null, selectedItem);
    gObj._addConnectorLine(selectedItem);
    gObj._updatedConnectorLineCollection = [];
    gObj._connectorlineIds = [];
    gObj._validatePredecessor(selectedItem, null);
    if (gObj._updatedConnectorLineCollection.length > 0) {
        gObj._$ganttchartHelper.ejGanttChart("appendConnectorLine", gObj._updatedConnectorLineCollection);
    }
    var args = {};
    args.data = selectedItem;
    gObj._updateScheduleDatesOnEditing(args);
}

//Re render Gantt chart side alone.
function reRenderGanttChartSide() {
    var gObj = $("#gantt").data("ejGantt"),
        model = gObj.model;
    gObj._updateModelsWidth();
    //Re render the gantt chart side alone
    gObj.updateScheduleDates(model.scheduleStartDate, model.scheduleEndDate);
    // Update the scrollbar to focus the selected taskbar while zooming
    var selectedItemIndex = gObj.selectedRowIndex();
    if (selectedItemIndex >= 0) {
        gObj.focusOnTask(selectedItemIndex);
    }
}
//Event for attachment, oneNote, chat items icon click
function customColumnEvents(args) {
    ganttObj = $("#gantt").data("ejGantt");
    target = args.target;
    var rowIndex = $(target).closest("tr").index(),
        record = ganttObj.model.currentViewData[rowIndex],
        className = $(target).attr("class");
    //if ($(target).hasClass("attachItems")) {
    //    angular.element(document.getElementById('gantt')).scope().attachmentModel(record.taskId);
    //}
    if (className == "chatItems") {
        // alert("Chat Items of Task Id " + record.taskId);
    }
    if (className == "oneNoteItems") {
        //alert("One Note Items of Task Id " + record.taskId);
    }

}

//select record and its child records
function selectChildRecords(record, checkStatus) {
    var ganttObj = $("#gantt").data("ejGantt"),
        length = 0, childRecords;
    record.result = checkStatus;
    record.item["result"] = checkStatus;
    alertDetails(record);
    refresh(record, ganttObj.model.updatedRecords);
    if (record.hasChildRecords) {
        childRecords = record.childRecords;
        length = childRecords.length;
        for (var count = 0; count < length; count++) {
            if (childRecords[count].hasChildRecords) {
                selectSubChildRecords(childRecords[count], checkStatus);
            }
            else {
                childRecords[count].result = checkStatus;
                childRecords[count].item["result"] = checkStatus;
                alertDetails(childRecords[count]);
                refresh(childRecords[count], ganttObj.model.updatedRecords);
            }
        }
    }
    updateParentItem(record);
}

//select record and its child records
function selectSubChildRecords(record, checkStatus) {
    var ganttObj = $("#gantt").data("ejGantt"),
        length = 0, childRecords;
    record.result = checkStatus;
    record.item["result"] = checkStatus;
    alertDetails(record);
    refresh(record, ganttObj.model.updatedRecords);
    if (record.hasChildRecords) {
        childRecords = record.childRecords;
        length = childRecords.length;
        for (var count = 0; count < length; count++) {
            childRecords[count].result = checkStatus;
            childRecords[count].item["result"] = checkStatus;
            alertDetails(childRecords[count]);

            refresh(childRecords[count], ganttObj.model.updatedRecords);
            if (childRecords[count].hasChildRecords) {
                selectSubChildRecords(childRecords[count], checkStatus);
            }
        }
    }
}

//update parent check status
function updateParentItem(record) {

    var ganttObj = $("#gantt").data("ejGantt"),
        parentItem = record.parentItem, length = 0, isChanged = false;
    childRecords = parentItem && parentItem.childRecords;
    length = childRecords && childRecords.length;
    if (length > 0) {
        var checkedChildRecords = childRecords.filter(function (record) {
            return record.result;
        });

        if (length != checkedChildRecords.length) {
            if (parentItem.result != false) {
                parentItem.result = false;
                parentItem.item["result"] = false;
                isChanged = true;
            }
        }
        else {
            if (parentItem.result != true) {
                parentItem.result = true;
                parentItem.item["result"] = true;
                alertDetails(parentItem);
                isChanged = true;
            }
        }
        if (isChanged) {
            refresh(parentItem, ganttObj.model.updatedRecords);
            if (parentItem.parentItem)
                updateParentItem(parentItem);
        }
    }
}

//Refresh rows while checkStatus changed
function refresh(record, updatedRecords) {
    var ganttObj = $("#gantt").data("ejGantt"),
        index = updatedRecords.indexOf(record);
    if (index !== -1) {
        ganttObj._$treegridHelper.ejTreeGrid("refreshRow", index);
    }
}

function alertDetails(rec) {
    var newString = rec.serialNumber + ". " + rec.taskName + "\n";
    alertString += newString;
}

function checkColumnPpty(args) {
    var curColum = args.currentColumn,
        tColumns = args.colums,
        curColumIndex = tColumns.indexOf(curColum),      
        leftM = false, rightM = false, firstM = false, lastM = false;
    //For left and first
        for (var l = (curColumIndex - 1) ; l >= 0; l--) {
            if (tColumns[l].visible && !tColumns[l].isFrozen) {
                leftM = true;
                firstM = true;
                break;
            }            
        }
    //For right and last
        for (var k = (curColumIndex + 1) ; k < tColumns.length; k++) {
            if (tColumns[k].visible) {
                rightM = true;
                lastM = true;
                break;
            }
        }
        var moveOptions = { "left": leftM, "right": rightM, "first": firstM, "last": lastM };
        return moveOptions;
}

function actionBegin(args) {
    if (args.requestType == "validatePredecessor") {
        if (!(args.fromItem.item.isSync && args.toItem.item.isSync))
            args.cancel = true;
    }
    else if (args.requestType == "save") {
        if (args.currentRecord) {
            args.data.customResources = args.data.resource.map(function (elem) {
                return elem.resourceName;
            }).join(",");
        }
        else
            args.data.customResources = args.data.resource.join(",");
    }
    else if (args.element && args.requestType == "openAddDialog") {
        $("#ganttAddAreaNotes_Iframe").height("205");
    }
    else if (args.requestType == "openEditDialog") {
        $("#ganttEditAreaNotes_Iframe").height("205");
        var resource = args.data.item.customResources, length, data = [];
        if (resource != null && resource != "") {
            resource = resource.split(",");
            length = resource.length;
            for (var i = 0; i < length; i++) {
                data.push({ "resourceName": resource[i] });
            }
        }
        args.data.resourceInfo = data;
    }
    else if (args.requestType == "headerClick") {
        //To header text popover        
        if (args.currentColumn.field == "serialNumber") {
            angular.element(document.getElementById('search_Gantt')).val('');
            angular.element(document.getElementById('gantt')).scope().showSearchBox(event, args);
        }
        else if (args.currentColumn.field == "result")
            args.cancel = true;
        else if (!args.currentColumn.isFrozen && args.currentColumn.isFrozen != true) {
            var moveOpts = checkColumnPpty(args);
            angular.element(document.getElementById('gantt')).scope().showColumnRearrangePopover(event, args);

               $("#MoveLeft").prop('disabled', !moveOpts.left);
                $("#MoveFirst").prop('disabled', !moveOpts.first);
                $("#MoveRight").prop('disabled', !moveOpts.right);
                $("#MoveLast").prop('disabled', !moveOpts.last);
         
        }
        else {
            //  angular.element(document.getElementById('gantt')).scope().showHeaderTextColumnTitle(event, args);
        }
    }
    else if (args.requestType == "cellMouseUp") {

            if ($(args.target).closest(".e-treegridcollapse,.e-treegridexpand").length > 0)
                return true;
            editSelectedTask = args.data;
            var ganttObj = $("#gantt").data("ejGantt"),
                selectedItem = ganttObj.model.selectedItem,
                selectedItemIndex = args.rowIndex,
                cellIndex = args.cellIndex;
            if (selectedItem && !ej.isNullOrUndefined(cellIndex) && cellIndex >= 0 && currentSelectedItemIndex >= 0 && selectedItemIndex == currentSelectedItemIndex) {
                var fieldName = ganttObj.model.columns[cellIndex].field,
                    value = fieldName == "taskMode" ? selectedItem["isAutoSchedule"] : selectedItem[fieldName];//It holds the clicked cell value
                ganttObj._isPopupRendering = true;
                //alert(value);
                //for showing popover based on header
                if (ScheduleLockedOrLinkActive() == true) {
                    if (fieldName == "serialNumber")
                        angular.element(document.getElementById('gantt')).scope().showTaskMenuPopover(event, editSelectedTask, args);
                    else if (fieldName == "taskName")
                        angular.element(document.getElementById('gantt')).scope().showTaskNamePopover(event, editSelectedTask);
                    else if (fieldName == "startDate") {
                        if (editSelectedTask.hasChildRecords == true)
                            angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Start date of task group is automatic");
                        else
                            angular.element(document.getElementById('gantt')).scope().showGantTaskStartDate(event, editSelectedTask);
                    }
                    else if (fieldName == "endDate") {
                        if (editSelectedTask.hasChildRecords == true)
                            angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "End date of task group is automatic");
                        else
                            angular.element(document.getElementById('gantt')).scope().showGantTaskEndDate(event, editSelectedTask);
                    }
                    else if (fieldName == "duration") {
                        if (editSelectedTask.hasChildRecords == true)
                            angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Duration of task group is automatic");
                        else
                            angular.element(document.getElementById('gantt')).scope().showTaskDuration(event, editSelectedTask);
                    }
                    else if (fieldName == "status") {
                        if (editSelectedTask.hasChildRecords == true)
                            angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Progress of task group is automatic");
                        else
                            angular.element(document.getElementById('gantt')).scope().showTaskProgress(event, editSelectedTask);
                    }
                    else if (fieldName == "notes")
                        angular.element(document.getElementById('gantt')).scope().showTaskNamePopover(event, editSelectedTask);
                    else if (fieldName == "taskMode") {
                        if (editSelectedTask.hasChildRecords == true)
                            angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Task mode of task group is automatic");
                        else
                            angular.element(document.getElementById('gantt')).scope().showGantTaskModePopover(event, editSelectedTask);
                    }
                        //else if (fieldName == "work")
                        //    angular.element(document.getElementById('gantt')).scope().showTaskWork(event, editSelectedTask);
                    else if (fieldName == "serialNumberPredecessor") {
                        if (editSelectedTask.hasChildRecords == true)
                            angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Task group does not support task link");
                        else
                            angular.element(document.getElementById('gantt')).scope().showTaskPredecessor(event, editSelectedTask);
                    }
                    else if (fieldName == "resourceInfo") {
                        angular.element(document.getElementById('gantt')).scope().showTaskResource(event, editSelectedTask);
                    }
                    else if (fieldName == "attachment") {
                        angular.element(document.getElementById('gantt')).scope().attachmentModel(editSelectedTask.taskId);
                    }
                    //if (cellIndex == 8 || cellIndex == 11) { //For Resource column and TaskMode column
                    //    var dropdownData = ganttObj.model.columns[cellIndex].dropdownData;//It holds the drop down values
                    //    console.log(dropdownData);
                    //}
                }
            }
            else {
                currentSelectedItemIndex = selectedItemIndex;
            }
      
    }
    else if(args.requestType == "DragAndDropParentCancel")
    {
        showNotification("Please collapse group before change sequence");
        //angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Collapse the row");
    }
}

function ScheduleLockedOrLinkActive() {
    var iconLock = $("#LockChange").attr('class').indexOf('lockclose') != -1 ? 'lockopen' : "lockclose";
    var iconLink = $("#TaskLink").attr('class').indexOf('linkblack') != -1 ? 'linkactive' : "linkblack";
    if (iconLock == 'lockopen') {
        angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Project locked.");
        return false;
    }
    else if (iconLink == 'linkblack') {
        angular.element(document.getElementById('gantt')).scope().taskEditNotification(event, "Project Link is Active. Please Disable to edit Task ");
        return false;
    }
    else {
        return true;
    }
}

function deleteSucess() {
    $("#gantt").ejGantt("deleteItem");
    $("#deleteConfirmDialog").ejDialog("close");
}

function deleteCancel() {
    $("#deleteConfirmDialog").ejDialog("close");
}

function customDelete() {
    $("#deleteConfirmDialog").ejDialog("open");
}

function setUiCustomize(value) {
    uiCustomize = value;
}
var selectedTaskIndex;
function ganttRowSelected(args) {
    if (selectedTaskIndex != this.selectedRowIndex()) {
        this.focusOnTask(this.selectedRowIndex());
        selectedTaskIndex = this.selectedRowIndex();
    }
}
var currentSelectedItemIndex;
//$(document).on("mouseup", ".e-rowcell", function (e) {    
//    var ganttObj = $("#gantt").data("ejGantt"),
//        selectedItem = ganttObj.model.selectedItem,
//        selectedItemIndex = ganttObj.model.currentViewData.indexOf(selectedItem),
//        treeObj = ganttObj._$treegridHelper.data("ejTreeGrid"),        
//        rowIndex = treeObj.getRowIndex(e),
//        cellIndex = treeObj.getCellIndex(e);
//    if (selectedItemIndex == currentSelectedItemIndex) {
//        var fieldName = ganttObj.model.columns[cellIndex].field,
//            value = fieldName == "taskMode" ? selectedItem["isAutoSchedule"] : selectedItem[fieldName];//It holds the clicked cell value   
//        //alert(value);

//                if (fieldName == "taskName")
//                    angular.element(document.getElementById('gantt')).scope().showTaskNamePopover(event, editSelectedTask);
//                else if (fieldName == "startDate")
//                    angular.element(document.getElementById('gantt')).scope().showGantTaskStartDate(event, editSelectedTask);
//                else if (fieldName == "endDate")
//                    angular.element(document.getElementById('gantt')).scope().showGantTaskEndDate(event, editSelectedTask);
//                else if (fieldName == "duration")
//                    angular.element(document.getElementById('gantt')).scope().showTaskDuration(event, editSelectedTask);
//                else if (fieldName == "status")
//                    angular.element(document.getElementById('gantt')).scope().showTaskProgress(event, editSelectedTask);
//                else if (fieldName == "notes")
//                    angular.element(document.getElementById('gantt')).scope().showTaskNamePopover(event, editSelectedTask);

//        if (cellIndex == 5 || cellIndex == 9 || cellIndex == 14) {
//            var dropdownData = ganttObj.model.columns[cellIndex].dropdownData;//It holds the drop down values            
//        }
//    }
//    else {
//        currentSelectedItemIndex = selectedItemIndex;
//    }   
//});
$(document).on("click", ".splitterCustom", function () {
    var ganttObj = $("#gantt").data("ejGantt"),
        ganttWidth = ganttObj._ganttWidth,
        splitterPosition = ganttObj.model.splitterSettings.position,
        leftPosition = Math.round(ganttWidth * (2 / 100)),
        rightPosition = Math.round(ganttWidth * (97 / 100)),
        centerPosition = Math.round(ganttWidth * (50 / 100));
    if (!ganttObj._splitterCentered) {
        ganttObj.setSplitterPosition(centerPosition.toString());
        ganttObj._splitterCentered = true;
    }
    else {
        if (splitterPosition.indexOf("%") != -1) {
            var value = splitterPosition.substring(0, splitterPosition.indexOf("%"));
            splitterPosition = (ganttWidth * (+value / 100)).toString();
        }
        if (splitterPosition == rightPosition) {
            ganttObj.setSplitterPosition(leftPosition.toString());
            ganttObj._splitterCentered = true;
        }
        else if (splitterPosition == leftPosition) {
            ganttObj.setSplitterPosition(centerPosition.toString());
            ganttObj._splitterCentered = true;
        }
        else if (splitterPosition == centerPosition) {
            ganttObj.setSplitterPosition(rightPosition.toString());
            ganttObj._splitterCentered = true;
        }
    }

});

function emptyRowClick() {
    
}

function changeScheduleHeaderSettings(scheduleMode, ganttTools) {
    if (scheduleMode == "week") {
        var uiCustomizeValue = ganttTools.uiCustomize;
        if (uiCustomizeValue.dayDisplay[0].DayNumberinMonth) {
            scheduleSettings.weekHeaderFormat = "d";
            scheduleSettings.dayHeaderFormat = "d";
            scheduleSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Week;
        }
        else {
            scheduleSettings.weekHeaderFormat = "MMM dd , yyyy";
            scheduleSettings.dayHeaderFormat = "";
            scheduleSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Week;
        }
    }
    else if (scheduleMode == "month") {
        scheduleSettings.monthHeaderFormat = "MMM yyyy";
        scheduleSettings.weekHeaderFormat = "M/dd";
        scheduleSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Month;
    }
    else if (scheduleMode == "year") {
        scheduleSettings.yearHeaderFormat = "MMM/yyyy";
        scheduleSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Year;
    }
    else if (scheduleMode == "day") {
        scheduleSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Day;
    }
}


//Header Check box click event
function headerCheck(args) {
    var ganttObj = $("#gantt").data("ejGantt"),
        checked = args.isChecked,
        allRecords = ganttObj.model.flatRecords,
        allRecordsLength = allRecords.length;
    if (checked) {
        isHeaderCheck = true;
        for (var i = 0; i < allRecordsLength; i++) {
            allRecords[i]["result"] = true;
            allRecords[i].item["result"] = true;
        }
    }
    else {
        isHeaderCheck = false;
        for (var i = 0; i < allRecordsLength; i++) {
            allRecords[i]["result"] = false;
            allRecords[i].item["result"] = false;
        }
    }
    //ganttObj._$treegridHelper.ejTreeGrid("refresh");
    var args = {};
    args.requestType = ej.TreeGrid.Actions.Refresh;
    ganttObj._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args)
}

function rowsCheckbox(args) {
    var ganttObj = $("#gantt").data("ejGantt"),
        rowIndex = this.element.closest("tr").index(),
        record = ganttObj.model.currentViewData[rowIndex],
        flatRecords = ganttObj.model.flatRecords,
        checkStatus = args.isChecked;
    selectChildRecords(record, checkStatus);
    var checkedRecords = flatRecords.filter(function (task) { return task.result });
    if (checkedRecords.length == flatRecords.length) {
        isHeaderCheck = true;
        $("#resultCheck").ejCheckBox({ checked: true });
    }
    else {
        isHeaderCheck = false;
        $("#resultCheck").ejCheckBox({ checked: false });
    }
    if (checkStatus)
        alertString;
    alertString = "";
}

function getScheduleResource() {
    //Request for get the shedule resource.
    if (navigator.onLine) {
        try {
            var request = new XMLHttpRequest(), resourceCollection = {};
            request.open('GET', url + 'schedule/' + scheduleId + '/task/0/resource', false);
            request.setRequestHeader('Authorization-Token', AuthToken);
            request.onreadystatechange = function () {
                if (this.readyState === 4) {
                    console.log('Status:', this.status);
                    console.log('Headers:', this.getAllResponseHeaders());
                    console.log('Body:', this.responseText);
                    var data = JSON.parse(this.responseText).data;
                    data = data && data.schedule_resource;
                    if (data) {
                        var length = data.length, resources = [], customResources = [];
                        for (var i = 0; i < length; i++) {
                            var resource = {};
                            resource.resourceName = data[i].resource_name;
                            resource.resourceId = data[i].resource_id;
                            resources.push(resource);
                            customResources.push(data[i].resource_name)
                        }
                        resourceCollection = {
                            resource: resources,
                            customResource: customResources
                        }
                    }
                    else {
                        resourceCollection = {
                            resource: [],
                            customResource: []
                        }
                        return resourceCollection;
                    }
                }
            }
            request.send();
            return resourceCollection;
        }
        catch (err) {
            resourceCollection = {
                resource: [],
                customResource: []
            }
            return resourceCollection;
        }
    }
    else {
        var resourceCollection = {};
        resourceCollection = {
            resource: [],
            customResource: []
        }
        return resourceCollection;
    }
}

//Convert the resource as JSON Assignments
//function getResource(data) {
//    var customResource = data.split(","),
//        length = customResource.length, resource = [],
//        resourceCollection = $("#gantt").ejGantt("instance").model.resources;
//    for (var i = 0; i < length; i++) {
//        var item = {};
//        var resourceId = $.map(resourceCollection, function (item, index) {
//            if (item["resourceName"].toString() == customResource[i]) {
//                return item.resourceId;
//            }
//        });
//        item.resource_id = resourceId[0];
//        item.assignment_unit = 1;
//        resource.push(item);
//    }
//    return resource;
//}

//Convert the JSON assignments as resource.
function getTaskResource(data, isId) {
    var length = data.length, resourceString = "", resourceCollection = [];
    if (!isId) {
        for (var i = 0; i < length; i++) {
            if (i != 0)
                resourceString += ",";
            var resourceName = $.map(overallResource, function (resource, index) {
                if (resource["resourceId"].toString() == data[i].resource_id) {
                    return resource.resourceName;
                }
            });
            resourceString += resourceName[0];
        }
        return resourceString;
    }
    else {
        for (var i = 0; i < length; i++) {
            resourceCollection.push(data[i].resource_id);
        }
        return resourceCollection;
    }
}
//function getTaskResourceUnit(data) {
//    var length = data.length, resourceString = "", resourceUnitCollection = [];
//    for (var i = 0; i < length; i++) {
//        resourceUnitCollection.push(data[i].assignment_unit);
//    }
//    return resourceUnitCollection;
//}

function GetWholeResourceCollection(data) {
    var resourceObjs = [],
        length = data.length;
    for (var i = 0; i < data.length; i++) {
        resourceObjs = resourceObjs.concat(data[i]["assignments"]);
    }
    var distinctResources = ej.distinct(resourceObjs, "resource_id", true);
    return distinctResources;
}

function GanttFilterBasedSelection(filterType) {
    var ganttObj = $("#gantt").data("ejGantt"),
        isDragAndDrop = true,
        flatRecords = ganttObj.model.flatRecords,
        length = flatRecords.length;
    for (var i = 0; i < length; i++)
    {
        if (flatRecords[i].hasChildRecords)
            flatRecords[i].expanded = true;
    }
    switch (filterType) {
        case "treeForm_tasks":
            /*No filter applied*/
            ganttObj.filterRecords(ej.Gantt.Filters.NoFilter);
            isDragAndDrop = true;
            break;
        case "listForm_tasks":
            /*Shows root tasks without childrens*/
            var predicate = ej.Predicate('hasChildRecords', ej.FilterOperators.notEqual, true, false);
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "nonWorking_days_tasks":
            /*Shows task which are fall on holidays*/
            ganttObj.filterRecords("nonWorking_days_tasks");
            isDragAndDrop = false;
            break;
        case "slow_tasks":
            /*Shows all tasks which are fall on today and progress precentage is less then 100*/
            var predicate = null,
                day = new Date();
            day.setHours(0, 0, 0, 0);
            predicate = ej.Predicate("endDate", ej.FilterOperators.lessThan, day, false)
                        .and("status", ej.FilterOperators.lessThan, 100);
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "notCompleted_tasks":
            /*Shows task which progress percentage lessthen 100 and schedule at before today*/
            //ganttObj.filterRecords(ej.Gantt.Filters.IncompletedTasks);
            var predicate = null,
                day = new Date();
            day.setHours(0, 0, 0, 0);
            predicate = ej.Predicate("endDate", ej.FilterOperators.lessThan, day, false)
                        .and("status", ej.FilterOperators.lessThan, 100);
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "lastMonth_tasks":
            /*Shows all tasks which are started in last month*/
            var today = new Date();
            var lastDay = new Date(today), firstDay;
            lastDay.setDate(0);
            lastDay.setHours(23, 59, 59, 999);
            firstDay = new Date(lastDay);
            firstDay.setDate(1);
            firstDay.setHours(0, 0, 0, 0);
            var predicate = ej.Predicate('startDate', ej.FilterOperators.greaterThanOrEqual, firstDay, false)
            .and("startDate", ej.FilterOperators.lessThanOrEqual, lastDay, false);
            predicate = predicate.or(ej.Predicate('endDate', ej.FilterOperators.greaterThanOrEqual, firstDay, false)
            .and("endDate", ej.FilterOperators.lessThanOrEqual, lastDay, false));
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "lastWeek_tasks":
            /*Shows all tasks which are started in last week*/
            var lastWeekEndDate = new Date();
            lastWeekEndDate.setHours(23, 59, 59, 999);
            var lastWeekEndDay = lastWeekEndDate.getDate() - lastWeekEndDate.getDay();
            lastWeekEndDate.setDate(lastWeekEndDay);
            var lastWeekStartDay = new Date(lastWeekEndDate);
            lastWeekStartDay.setHours(0, 0, 0, 0);
            lastWeekStartDay.setDate(lastWeekStartDay.getDate() - 7);
            var predicate = ej.Predicate('startDate', ej.FilterOperators.greaterThanOrEqual, lastWeekStartDay, false)
            .and("startDate", ej.FilterOperators.lessThanOrEqual, lastWeekEndDate, false);
            predicate = predicate.or(ej.Predicate('endDate', ej.FilterOperators.greaterThanOrEqual, lastWeekStartDay, false)
            .and("endDate", ej.FilterOperators.lessThanOrEqual, lastWeekEndDate, false));
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "today_inProgress_tasks":
            /*Shows all tasks which are fall on today and progress precentage is less then 100*/
            var predicate = null,
                day = new Date();
            day.setHours(0, 0, 0, 0);
            var endDay = new Date(day);
            endDay.setHours(23, 59, 59, 999);
            predicate = ej.Predicate("startDate", ej.FilterOperators.lessThanOrEqual, day, false).and("endDate", ej.FilterOperators.greaterThanOrEqual, day, false)
                        .and("status", ej.FilterOperators.lessThan, 100);
            predicate = predicate.or(ej.Predicate("startDate", ej.FilterOperators.greaterThanOrEqual, day, false).and("startDate", ej.FilterOperators.lessThanOrEqual, endDay, false)
                        .and("status", ej.FilterOperators.lessThan, 100));
            predicate = predicate.or(ej.Predicate("endDate", ej.FilterOperators.greaterThanOrEqual, day, false).and("endDate", ej.FilterOperators.lessThanOrEqual, endDay, false)
                        .and("status", ej.FilterOperators.lessThan, 100));
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "thisWeek_tasks":
            /*Shows all task which are started in current week*/
            var lastWeekStartDate = new Date();
            lastWeekStartDate.setHours(0, 0, 0, 0);
            var lastWeekStartDay = lastWeekStartDate.getDate() - lastWeekStartDate.getDay();
            lastWeekStartDate.setDate(lastWeekStartDay);
            var lastWeekEndDate = new Date(lastWeekStartDate);
            lastWeekEndDate.setHours(23, 59, 59, 59);
            lastWeekEndDate.setDate(lastWeekEndDate.getDate() + 7);
            var predicate = ej.Predicate('startDate', ej.FilterOperators.greaterThan, lastWeekStartDate, false)
            .and("startDate", ej.FilterOperators.lessThan, lastWeekEndDate, false);
            predicate = predicate.or(ej.Predicate('endDate', ej.FilterOperators.greaterThan, lastWeekStartDate, false)
            .and("endDate", ej.FilterOperators.lessThan, lastWeekEndDate, false));
            ganttObj.filterRecords(predicate);
            isDragAndDrop = false;
            break;
        case "thisMonth_tasks":
            /*Shows all task which are started in current month*/
            var today = new Date();
            var lastDay = new Date(today), firstDay;
            lastDay.setMonth(lastDay.getMonth() + 1);
            lastDay.setDate(0);
            lastDay.setHours(23, 59, 59, 999);
            firstDay = new Date(lastDay);
            firstDay.setDate(1);
            firstDay.setHours(0, 0, 0, 0);
            var predicate = ej.Predicate('startDate', ej.FilterOperators.greaterThanOrEqual, firstDay, false)
            .and("startDate", ej.FilterOperators.lessThanOrEqual, lastDay, false);
            predicate = predicate.or(ej.Predicate('endDate', ej.FilterOperators.greaterThanOrEqual, firstDay, false)
            .and("endDate", ej.FilterOperators.lessThanOrEqual, lastDay, false));
            ganttObj.filterRecords(predicate);
            break;
            isDragAndDrop = false;
    }
    //ganttObj.setModel({"dragAndDrop": isDragAndDrop});
    ganttObj.option("allowDragAndDrop", isDragAndDrop);
}