angular.module('starter.controllers', [])

.controller('DashCtrl', function ($scope) { })

.controller('ChatsCtrl', function ($scope, Chats) {
    // With the new view caching in Ionic, Controllers are only called
    // when they are recreated or on app start, instead of every page change.
    // To listen for when this page is active (for example, to refresh data),
    // listen for the $ionicView.enter event:
    //
    //$scope.$on('$ionicView.enter', function(e) {
    //});

    $scope.chats = Chats.all();
    $scope.remove = function (chat) {
        Chats.remove(chat);
    };
})
    .controller('LoginCtrl', function ($scope, LoginService, $ionicPopup, $state) {
        //Remote Data
        $scope.dataManger = new ej.DataManager({
		    url: "http://mvc.syncfusion.com/Services/Northwnd.svc/"
        });
        $scope.chartSize = { height: '350', width:'800' };
        $scope.query = ej.Query().from("Orders").take(10);
        $scope.barcommonSeriesOptions = { type: 'column', enableAnimation: true, marker: { dataLabel: { visible: false } } };
        $scope.title1 = { text: 'Local Data' };
        $scope.title2 = { text: 'Remote Data' };
        $scope.barlegend = { visible: false };
        $scope.barprimaryXAxis = { title: { text: 'Year' }, range: { min: 2005, max: 2012, interval: 1 }, labelIntersectAction: "hide" };
        //Local Data
        $scope.chartLoad = function (sender) {
            var chartData = [{ xName: 2006, yName: 7.8}, { xName: 2007, yName: 7.2 }, { xName: 2008, yName: 6.8 }, { xName: 2009, yName: 10.7 }, { xName: 2010, yName: 10.8 }, { xName: 2011, yName: 9.8}];
            sender.model.series[0].dataSource = chartData;
        }
        
        $scope.data = [{
            id: "SF1738",
            name: 'Akbar Basha',
            password: 1738,
            username: "Akbar",
            lastText: 'Knows What to do',
            face: 'img/akbar.png'
        }, {
            id: "SF1739",
            name: 'Balachandar',
            password: 1739,
            username: "Bala",
            lastText: 'Hey, it\'s me',
            face: 'img/bala.png'
        }, {
            id: "SF1740",
            name: 'Sundarraj',
            password: 1740,
            username: "Sundar",
            lastText: 'I should buy a boat',
            face: 'img/sundar.png'
        }, {
            id: "SF1741",
            name: 'John',
            password: 1741,
            username: "John",
            lastText: 'Look at my mukluks!',
            face: 'img/john.png'
        }, {
            id: "SF1742",
            name: 'Jagan',
            password: 1742,
            username: "Jagan",
            lastText: 'chatting with my GF',
            face: 'img/jagan.png'
        }, {
            id: "SF1743",
            name: 'Panjanathan',
            password: 1743,
            username: "Panju",
            lastText: 'This is wicked good ice cream.',
            face: 'img/panju.png'
        }, {
            password: "Coordinator",
            username: "Coordinator"
        }
        ];


        $scope.login = function () {
            LoginService.loginUser($scope.data.username, $scope.data.password, $scope.data).success(function (data) {
                if ($scope.data.password === "Coordinator" && $scope.data.username === "Coordinator") {
                    $state.go('coordinate'); 
                } else {
                    $state.go('options');
                }
                sessionStorage.setItem('un', $scope.data.username);
                sessionStorage.setItem('lateNumCount', 0);
            }).error(function (data) {
                var alertPopup = $ionicPopup.alert({
                    title: 'Login failed!',
                    template: 'Please check your credentials!'
                });
            });
        }
    })
.controller('ChatDetailCtrl', function ($scope, $stateParams, Chats) {
    $scope.chat = Chats.get($stateParams.chatId);
})

.controller('AccountCtrl', function ($scope) {
    $scope.settings = {
        enableFriends: true
    };
})



