angular.module('starter.services', [])
.service('LoginService', function ($q) {
    return {
        loginUser: function (name, pw, data) {
            var deferred = $q.defer();
            var promise = deferred.promise;
            var accept = data.some(function (value) {
                if (name == value.username && pw == value.password) {
                    sessionStorage.setItem('currentEmpid', value.id);
                    return true;
                }
                else {
                    return false;
                }
            })
            if (accept) {
                deferred.resolve('Welcome ' + name + '!');
            } else {
                deferred.reject('Wrong credentials.');
            }
            promise.success = function (fn) {
                promise.then(fn);
                return promise;
            }
            promise.error = function (fn) {
                promise.then(null, fn);
                return promise;
            }
            return promise;
        }
    }
})
.factory('Chats', function() {
  // Might use a resource here that returns a JSON array

  // Some fake testing data
  var chats = [{
    id: 0,
    name: 'Akbar Basha',
    lastText: 'Knows What to do',
    face: 'img/akbar.png'
  }, {
    id: 1,
    name: 'Balachandar',
    lastText: 'Hey, it\'s me',
    face: 'img/bala.png'
  }, {
    id: 2,
    name: 'Sundarraj',
    lastText: 'I should buy a boat',
    face: 'img/sundar.png'
  }, {
    id: 3,
    name: 'John',
    lastText: 'Look at my mukluks!',
    face: 'img/john.png'
  }, {
    id: 4,
    name: 'Jagan',
    lastText: 'chatting with my GF',
    face: 'img/jagan.png'
  },{
      id: 5,
      name: 'Panjanathan',
      lastText: 'This is wicked good ice cream.',
      face: 'img/panju.png'
  }
  ];

  return {
    all: function() {
      return chats;
    },
    remove: function(chat) {
      chats.splice(chats.indexOf(chat), 1);
    },
    get: function(chatId) {
      for (var i = 0; i < chats.length; i++) {
        if (chats[i].id === parseInt(chatId)) {
          return chats[i];
        }
      }
      return null;
    }
  };

})
.factory('OptionsDetail', function () {
    // Might use a resource here that returns a JSON array

    // Some fake testing data
    var option = [
        {
        "id": 1,
        "name": "Leave System",
        "url": "leave"

        },
        {
             "id": 2,
             "name": "PaySlip",
            "url":"payslip"
        },
        {
            "id": 3,
            "name": "E-Books",
            "url": "e-books"
        },
        {
            "id": 4,
            "name": "Library",
            "url": "library"
        },
        {
            "id": 5,
            "name": "Stress Relief",
            "url": "stress"
        },
        {
            "id": 6,
            "name": "Log-Out",
            "url": "logout"
        }
    ];

    return {
        all: function () {
            return option;
        },
        //remove: function (chat) {
        //    chats.splice(chats.indexOf(chat), 1);
        //},
        //get: function (chatId) {
        //    for (var i = 0; i < chats.length; i++) {
        //        if (chats[i].id === parseInt(chatId)) {
        //            return chats[i];
        //        }
        //    }
        //    return null;
        //}
    };

});;

